import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { GoodsLog, GoodsLogParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品日志表
 */
export async function pageGoodsLog(params: GoodsLogParam) {
  const res = await request.get<ApiResult<PageResult<GoodsLog>>>(
    MODULES_API_URL + '/shop/goods-log/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品日志表列表
 */
export async function listGoodsLog(params?: GoodsLogParam) {
  const res = await request.get<ApiResult<GoodsLog[]>>(
    MODULES_API_URL + '/shop/goods-log',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品日志表
 */
export async function addGoodsLog(data: GoodsLog) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品日志表
 */
export async function updateGoodsLog(data: GoodsLog) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-log',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品日志表
 */
export async function removeGoodsLog(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-log/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品日志表
 */
export async function removeBatchGoodsLog(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-log/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品日志表
 */
export async function getGoodsLog(id: number) {
  const res = await request.get<ApiResult<GoodsLog>>(
    MODULES_API_URL + '/shop/goods-log/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
